=== debian/changelog ===
ros-crystal-micro-xrce-dds-agent (1.0.3-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Borja Outerelo <borjaouterelo@eprosima.com>  Wed, 24 Apr 2019 09:05:34 -0000
