=== debian/control ===
Source: ros-crystal-micro-xrce-dds-agent
Section: misc
Priority: extra
Maintainer: Borja Outerelo <borjaouterelo@eprosima.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libasio-dev, ros-crystal-fastcdr, ros-crystal-fastrtps, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-micro-xrce-dds-agent
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-fastcdr, ros-crystal-fastrtps, ros-crystal-ros-workspace
Description: DDS-XCRE agent implementation
